const express = require("express");
const router = express.Router();
const authorize = require("../../../../middlewares/authorize-sapps");
const clientService = require("./client.service");
const redisClient = require('../../../../redisClient');

router.post("/create", authorize(), create);
router.post("/mass-update", authorize(), massUpdateCode);
router.get("/", authorize(), getAll);
router.get("/filter", authorize(), filter);
router.get("/option", authorize(), option);
router.get("/count", authorize(), count);
router.put("/:id", authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete("/:id", authorize(), _delete);

module.exports = router;

function create(req, res, next) {
    clientService
        .create(req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function massUpdateCode(req, res, next) {
    clientService
        .massUpdateCode(req.body)
        .then((result) => res.json(result))
        .catch(next);
}

async function getAll(req, res, next) {
    try {
        // Membuat cacheKey berdasarkan req.query
        const cacheKey = `statuses:${JSON.stringify(req.query)}-clients`;

        // Mengecek apakah data sudah ada di Redis
        const cachedData = await redisClient.get(cacheKey);
        if (cachedData) {
            return res.json(JSON.parse(cachedData));
        }

        // Jika tidak ada, panggil clientService.getAll(req.query)
        const result = await clientService.getAll(req.query);

        // Simpan hasilnya ke Redis dengan expire time misalnya 60 detik
        await redisClient.setEx(cacheKey, 60, JSON.stringify(result));

        // Kembalikan response JSON dari hasil panggilan service
        return res.json(result);
    } catch (error) {
        return next(error);
    }
}

// function getAll(req, res, next) {
//   clientService
//     .getAll(req.query)
//     .then((result) => res.json(result))
//     .catch(next);
// }

function filter(req, res, next) {
    clientService
        .filter(req.query)
        .then((result) => res.json(result))
        .catch(next);
}

async function option(req, res, next) {
    try {
        // Membuat cacheKey
        const cacheKey = `clients-options`;

        // Mengecek apakah data sudah ada di Redis
        const cachedData = await redisClient.get(cacheKey);
        if (cachedData) {
            return res.json(JSON.parse(cachedData));
        }

        // Jika tidak ada, panggil clientService.option()
        const result = await clientService.option();

        // Simpan hasilnya ke Redis dengan expire time misalnya 60 detik
        await redisClient.setEx(cacheKey, 60, JSON.stringify(result));

        // Kembalikan response JSON dari hasil panggilan service
        return res.json(result);
    } catch (error) {
        return next(error);
    }
}

// function option(req, res, next) {
//     clientService
//         .option()
//         .then((result) => res.json(result))
//         .catch(next);
// }

function count(req, res, next) {
    clientService
        .count()
        .then((result) => res.json(result))
        .catch(next);
}

function update(req, res, next) {
    clientService
        .update(req.params.id, req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function enabled(req, res, next) {
    clientService.enabled(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

function _delete(req, res, next) {
    clientService
        .delete(req.params.id)
        .then((result) => res.json(result))
        .catch(next);
}
